﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using SailingBoatPathFinder.Data;

namespace SailingBoatPathFinder.Data.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    [Migration("20201212195719_Create_Database")]
    partial class Create_Database
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .UseIdentityColumns()
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("ProductVersion", "5.0.0");

            modelBuilder.Entity("BoatBoatProperty", b =>
                {
                    b.Property<Guid>("OwnerBoatId")
                        .HasColumnType("uniqueidentifier");

                    b.Property<Guid>("PropertiesId")
                        .HasColumnType("uniqueidentifier");

                    b.HasKey("OwnerBoatId", "PropertiesId");

                    b.HasIndex("PropertiesId");

                    b.ToTable("BoatBoatProperty");
                });

            modelBuilder.Entity("SailingBoatPathFinder.Data.Entities.Boat", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier");

                    b.Property<string>("Type")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Boat");
                });

            modelBuilder.Entity("SailingBoatPathFinder.Data.Entities.BoatProperty", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier");

                    b.Property<double>("BeatAngle")
                        .HasColumnType("float");

                    b.Property<double>("BeatVMG")
                        .HasColumnType("float");

                    b.Property<double>("RunAngle")
                        .HasColumnType("float");

                    b.Property<double>("RunVMG")
                        .HasColumnType("float");

                    b.Property<int>("WindVelocity")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.ToTable("BoatProperty");
                });

            modelBuilder.Entity("SailingBoatPathFinder.Data.Entities.PolarData", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier");

                    b.Property<double>("Angle")
                        .HasColumnType("float");

                    b.Property<double>("BoatVelocity")
                        .HasColumnType("float");

                    b.Property<Guid?>("OwnerBoatId")
                        .HasColumnType("uniqueidentifier");

                    b.Property<double>("WindVelocity")
                        .HasColumnType("float");

                    b.HasKey("Id");

                    b.HasIndex("OwnerBoatId");

                    b.ToTable("PolarData");
                });

            modelBuilder.Entity("BoatBoatProperty", b =>
                {
                    b.HasOne("SailingBoatPathFinder.Data.Entities.Boat", null)
                        .WithMany()
                        .HasForeignKey("OwnerBoatId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("SailingBoatPathFinder.Data.Entities.BoatProperty", null)
                        .WithMany()
                        .HasForeignKey("PropertiesId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("SailingBoatPathFinder.Data.Entities.PolarData", b =>
                {
                    b.HasOne("SailingBoatPathFinder.Data.Entities.Boat", "OwnerBoat")
                        .WithMany("PolarDatas")
                        .HasForeignKey("OwnerBoatId");

                    b.Navigation("OwnerBoat");
                });

            modelBuilder.Entity("SailingBoatPathFinder.Data.Entities.Boat", b =>
                {
                    b.Navigation("PolarDatas");
                });
#pragma warning restore 612, 618
        }
    }
}
